- Main Page
- Modules
- Data Structures
- Files
- Related Pages

- Search for |

- Alphabetical List
- Data Structures
- Class Hierarchy
- Data Fields

# TimeZone Class Reference

`TimeZone` represents a time zone offset, and also figures out daylight savings. More...

`#include <timezone.h>`

Inheritance diagram for TimeZone:

## Public Types
enum | EDisplayType { SHORT = 1, LONG }
| Enum for use with getDisplayName. More...
## Public Member Functions
virtual | ~TimeZone ()
virtual UBool | operator== (const TimeZone &that) const
| Returns true if the two TimeZones are equal.
UBool | operator!= (const TimeZone &that) const
| Returns true if the two TimeZones are NOT equal; that is, if operator==() returns false.
virtual int32_t | getOffset (uint8_t era, int32_t year, int32_t month, int32_t day, uint8_t dayOfWeek, int32_t millis, UErrorCode &status) const =0
| Returns the TimeZone's adjusted GMT offset (i.e., the number of milliseconds to add to GMT to get local time in this time zone, taking daylight savings time into account) as of a particular reference date.
virtual int32_t | getOffset (uint8_t era, int32_t year, int32_t month, int32_t day, uint8_t dayOfWeek, int32_t milliseconds, int32_t monthLength, UErrorCode &status) const=0
| Gets the time zone offset, for current date, modified in case of daylight savings.
virtual void | getOffset (UDate date, UBool local, int32_t &rawOffset, int32_t &dstOffset, UErrorCode &ec) const
| Returns the time zone raw and GMT offset for the given moment in time.
virtual void | setRawOffset (int32_t offsetMillis)=0
| Sets the TimeZone's raw GMT offset (i.e., the number of milliseconds to add to GMT to get local time, before taking daylight savings time into account).
virtual int32_t | getRawOffset (void) const =0
| Returns the TimeZone's raw GMT offset (i.e., the number of milliseconds to add to GMT to get local time, before taking daylight savings time into account).
UnicodeString & | getID (UnicodeString &ID) const
| Fills in "ID" with the TimeZone's ID.
void | setID (const UnicodeString &ID)
| Sets the TimeZone's ID to the specified value.
UnicodeString & | getDisplayName (UnicodeString &result) const
| Returns a name of this time zone suitable for presentation to the user in the default locale.
UnicodeString & | getDisplayName (const Locale &locale, UnicodeString &result) const
| Returns a name of this time zone suitable for presentation to the user in the specified locale.
UnicodeString & | getDisplayName (UBool daylight, EDisplayType style, UnicodeString &result) const
| Returns a name of this time zone suitable for presentation to the user in the default locale.
UnicodeString & | getDisplayName (UBool daylight, EDisplayType style, const Locale &locale, UnicodeString &result) const
| Returns a name of this time zone suitable for presentation to the user in the specified locale.
virtual UBool | useDaylightTime (void) const =0
| Queries if this time zone uses daylight savings time.
virtual UBool | inDaylightTime (UDate date, UErrorCode &status) const=0
| Queries if the given date is in daylight savings time in this time zone.
virtual UBool | hasSameRules (const TimeZone &other) const
| Returns true if this zone has the same rule and offset as another zone.
virtual TimeZone * | clone (void) const =0
| Clones TimeZone objects polymorphically.
virtual UClassID | getDynamicClassID (void) const =0
| Returns a unique class ID POLYMORPHICALLY.
virtual int32_t | getDSTSavings () const
| Returns the amount of time to be added to local standard time to get local wall clock time.
## Static Public Member Functions
static const TimeZone * | getGMT (void)
| The GMT time zone has a raw offset of zero and does not use daylight savings time.
static TimeZone * | createTimeZone (const UnicodeString &ID)
| Creates a `TimeZone` for the given ID.
static StringEnumeration * | createEnumeration ()
| Returns an enumeration over all recognized time zone IDs.
static StringEnumeration * | createEnumeration (int32_t rawOffset)
| Returns an enumeration over time zone IDs with a given raw offset from GMT.
static StringEnumeration * | createEnumeration (const char *country)
| Returns an enumeration over time zone IDs associated with the given country.
static int32_t | countEquivalentIDs (const UnicodeString &id)
| Returns the number of IDs in the equivalency group that includes the given ID.
static const UnicodeString | getEquivalentID (const UnicodeString &id, int32_t index)
| Returns an ID in the equivalency group that includes the given ID.
static TimeZone * | createDefault (void)
| Creates a new copy of the default TimeZone for this host.
static void | adoptDefault (TimeZone *zone)
| Sets the default time zone (i.e., what's returned by createDefault()) to be the specified time zone.
static void | setDefault (const TimeZone &zone)
| Same as adoptDefault(), except that the TimeZone object passed in is NOT adopted; the caller remains responsible for deleting it.
static const char * | getTZDataVersion (UErrorCode &status)
| Returns the timezone data version currently used by ICU.
static UClassID | getStaticClassID (void)
| Return the class ID for this class.
## Protected Member Functions
| TimeZone ()
| Default constructor.
| TimeZone (const UnicodeString &id)
| Construct a timezone with a given ID.
| TimeZone (const TimeZone &source)
| Copy constructor.
TimeZone & | operator= (const TimeZone &right)
| Default assignment operator.
## Static Protected Member Functions
static UResourceBundle * | loadRule (const UResourceBundle *top, const UnicodeString &ruleid, UResourceBundle *oldbundle, UErrorCode &status)
| Utility function.

## Detailed Description

`TimeZone` represents a time zone offset, and also figures out daylight savings.

Typically, you get a `TimeZone` using `createDefault` which creates a `TimeZone` based on the time zone where the program is running. For example, for a program running in Japan, `createDefault` creates a `TimeZone` object based on Japanese Standard Time.

You can also get a `TimeZone` using `createTimeZone` along with a time zone ID. For instance, the time zone ID for the Pacific Standard Time zone is "PST". So, you can get a PST `TimeZone` object with:

>      TimeZone *tz = TimeZone::createTimeZone("PST");

You can use `getAvailableIDs` method to iterate through all the supported time zone IDs. You can then choose a supported ID to get a `TimeZone`. If the time zone you want is not represented by one of the supported IDs, then you can create a custom time zone ID with the following syntax:

>      GMT[+|-]hh[[:]mm]

For example, you might specify GMT+14:00 as a custom time zone ID. The `TimeZone` that is returned when you specify a custom time zone ID does not include daylight savings time.

TimeZone is an abstract class representing a time zone. A TimeZone is needed for Calendar to produce local time for a particular time zone. A TimeZone comprises three basic pieces of information:

- A time zone offset; that, is the number of milliseconds to add or subtract from a time expressed in terms of GMT to convert it to the same time in that time zone (without taking daylight savings time into account).
- Logic necessary to take daylight savings time into account if daylight savings time is observed in that time zone (e.g., the days and hours on which daylight savings time begins and ends).
- An ID. This is a text string that uniquely identifies the time zone.

(Only the ID is actually implemented in TimeZone; subclasses of TimeZone may handle daylight savings time and GMT offset in different ways. Currently we only have one TimeZone subclass: SimpleTimeZone.)

The TimeZone class contains a static list containing a TimeZone object for every combination of GMT offset and daylight-savings time rules currently in use in the world, each with a unique ID. Each ID consists of a region (usually a continent or ocean) and a city in that region, separated by a slash, (for example, Pacific Standard Time is "America/Los_Angeles.") Because older versions of this class used three- or four-letter abbreviations instead, there is also a table that maps the older abbreviations to the newer ones (for example, "PST" maps to "America/LosAngeles"). Anywhere the API requires an ID, you can use either form.

To create a new TimeZone, you call the factory function TimeZone::createTimeZone() and pass it a time zone ID. You can use the createEnumeration() function to obtain a list of all the time zone IDs recognized by createTimeZone().

You can also use TimeZone::createDefault() to create a TimeZone. This function uses platform-specific APIs to produce a TimeZone for the time zone corresponding to the client's computer's physical location. For example, if you're in Japan (assuming your machine is set up correctly), TimeZone::createDefault() will return a TimeZone for Japanese Standard Time ("Asia/Tokyo").

Definition at line 122 of file timezone.h.

## Member Enumeration Documentation

enum TimeZone::EDisplayType

Enum for use with getDisplayName.

Stable:
  ICU 2.4

Enumerator:

  SHORT | Selector for short display name. Stable: ICU 2.4
  LONG | Selector for long display name. Stable: ICU 2.4

Definition at line 481 of file timezone.h.

## Constructor & Destructor Documentation

virtual TimeZone::~TimeZone | ( |  | ) | `[virtual]`

Stable:
  ICU 2.0

TimeZone::TimeZone | ( |  | ) | `[protected]`

Default constructor.

ID is initialized to the empty string.

Stable:
  ICU 2.0

TimeZone::TimeZone | ( | const UnicodeString & | id | ) | `[protected]`

Construct a timezone with a given ID.

Parameters:

  | id | a system time zone ID

Stable:
  ICU 2.0

TimeZone::TimeZone | ( | const TimeZone & | source | ) | `[protected]`

Copy constructor.

Parameters:

  | source | the object to be copied.

Stable:
  ICU 2.0

## Member Function Documentation

static const TimeZone* TimeZone::getGMT | ( | void |  | ) | `[static]`

The GMT time zone has a raw offset of zero and does not use daylight savings time.

This is a commonly used time zone.

Returns:
  the GMT time zone.

Stable:
  ICU 2.0

static TimeZone* TimeZone::createTimeZone | ( | const UnicodeString & | ID | ) | `[static]`

Creates a `TimeZone` for the given ID.

Parameters:

  | ID | the ID for a `TimeZone`, either an abbreviation such as "PST", a full name such as "America/Los_Angeles", or a custom ID such as "GMT-8:00".

Returns:
  the specified `TimeZone`, or the GMT zone if the given ID cannot be understood. Return result guaranteed to be non-null. If you require that the specific zone asked for be returned, check the ID of the return result.

Stable:
  ICU 2.0

static StringEnumeration* TimeZone::createEnumeration | ( |  | ) | `[static]`

Returns an enumeration over all recognized time zone IDs.

(i.e., all strings that createTimeZone() accepts)

Returns:
  an enumeration object, owned by the caller.

Stable:
  ICU 2.4

static StringEnumeration* TimeZone::createEnumeration | ( | int32_t | rawOffset | ) | `[static]`

Returns an enumeration over time zone IDs with a given raw offset from GMT.

There may be several times zones with the same GMT offset that differ in the way they handle daylight savings time. For example, the state of Arizona doesn't observe daylight savings time. If you ask for the time zone IDs corresponding to GMT-7:00, you'll get back an enumeration over two time zone IDs: "America/Denver," which corresponds to Mountain Standard Time in the winter and Mountain Daylight Time in the summer, and "America/Phoenix", which corresponds to Mountain Standard Time year-round, even in the summer.

Parameters:

  | rawOffset | an offset from GMT in milliseconds, ignoring the effect of daylight savings time, if any

Returns:
  an enumeration object, owned by the caller

Stable:
  ICU 2.4

static StringEnumeration* TimeZone::createEnumeration | ( | const char * | country | ) | `[static]`

Returns an enumeration over time zone IDs associated with the given country.

Some zones are affiliated with no country (e.g., "UTC"); these may also be retrieved, as a group.

Parameters:

  | country | The ISO 3166 two-letter country code, or NULL to retrieve zones not affiliated with any country.

Returns:
  an enumeration object, owned by the caller

Stable:
  ICU 2.4

static int32_t TimeZone::countEquivalentIDs | ( | const UnicodeString & | id | ) | `[static]`

Returns the number of IDs in the equivalency group that includes the given ID.

An equivalency group contains zones that have the same GMT offset and rules.

The returned count includes the given ID; it is always >= 1. The given ID must be a system time zone. If it is not, returns zero.

Parameters:

  | id | a system time zone ID

Returns:
  the number of zones in the equivalency group containing 'id', or zero if 'id' is not a valid system ID

See also:
  getEquivalentID

Stable:
  ICU 2.0

static const UnicodeString TimeZone::getEquivalentID | ( | const UnicodeString & | id,
|  | int32_t | index |
| ) |  |  | `[static]`

Returns an ID in the equivalency group that includes the given ID.

An equivalency group contains zones that have the same GMT offset and rules.

The given index must be in the range 0..n-1, where n is the value returned by `countEquivalentIDs(id)`. For some value of 'index', the returned value will be equal to the given id. If the given id is not a valid system time zone, or if 'index' is out of range, then returns an empty string.

Parameters:

  | id | a system time zone ID
  | index | a value from 0 to n-1, where n is the value returned by `countEquivalentIDs(id)`

Returns:
  the ID of the index-th zone in the equivalency group containing 'id', or an empty string if 'id' is not a valid system ID or 'index' is out of range

See also:
  countEquivalentIDs

Stable:
  ICU 2.0

static TimeZone* TimeZone::createDefault | ( | void |  | ) | `[static]`

Creates a new copy of the default TimeZone for this host.

Unless the default time zone has already been set using adoptDefault() or setDefault(), the default is determined by querying the system using methods in TPlatformUtilities. If the system routines fail, or if they specify a TimeZone or TimeZone offset which is not recognized, the TimeZone indicated by the ID kLastResortID is instantiated and made the default.

Returns:
  A default TimeZone. Clients are responsible for deleting the time zone object returned.

Stable:
  ICU 2.0

static void TimeZone::adoptDefault | ( | TimeZone * | zone | ) | `[static]`

Sets the default time zone (i.e., what's returned by createDefault()) to be the specified time zone.

If NULL is specified for the time zone, the default time zone is set to the default host time zone. This call adopts the TimeZone object passed in; the clent is no longer responsible for deleting it.

Parameters:

  | zone | A pointer to the new TimeZone object to use as the default.

Stable:
  ICU 2.0

static void TimeZone::setDefault | ( | const TimeZone & | zone | ) | `[static]`

Same as adoptDefault(), except that the TimeZone object passed in is NOT adopted; the caller remains responsible for deleting it.

Parameters:

  | zone | The given timezone.

System:
  Do not use unless you know what you are doing.

static const char* TimeZone::getTZDataVersion | ( | UErrorCode & | status | ) | `[static]`

Returns the timezone data version currently used by ICU.

Parameters:

  | status | Output param to filled in with a success or an error.

Returns:
  the version string, such as "2007f"

Draft:
  This API may be changed in the future versions and was introduced in ICU 3.8

virtual UBool TimeZone::operator== | ( | const TimeZone & | that | ) | const`[virtual]`

Returns true if the two TimeZones are equal.

(The TimeZone version only compares IDs, but subclasses are expected to also compare the fields they add.)

Parameters:

  | that | The TimeZone object to be compared with.

Returns:
  True if the given TimeZone is equal to this TimeZone; false otherwise.

Stable:
  ICU 2.0

Reimplemented in RuleBasedTimeZone, SimpleTimeZone, and VTimeZone.

UBool TimeZone::operator!= | ( | const TimeZone & | that | ) | const`[inline]`

Returns true if the two TimeZones are NOT equal; that is, if operator==() returns false.

Parameters:

  | that | The TimeZone object to be compared with.

Returns:
  True if the given TimeZone is not equal to this TimeZone; false otherwise.

Stable:
  ICU 2.0

Reimplemented in RuleBasedTimeZone, and VTimeZone.

Definition at line 356 of file timezone.h.

virtual int32_t TimeZone::getOffset | ( | uint8_t | era,
|  | int32_t | year,
|  | int32_t | month,
|  | int32_t | day,
|  | uint8_t | dayOfWeek,
|  | int32_t | millis,
|  | UErrorCode & | status |
| ) |  |  | const`[pure virtual]`

Returns the TimeZone's adjusted GMT offset (i.e., the number of milliseconds to add to GMT to get local time in this time zone, taking daylight savings time into account) as of a particular reference date.

The reference date is used to determine whether daylight savings time is in effect and needs to be figured into the offset that is returned (in other words, what is the adjusted GMT offset in this time zone at this particular date and time?). For the time zones produced by createTimeZone(), the reference data is specified according to the Gregorian calendar, and the date and time fields are local standard time.

Note: Don't call this method. Instead, call the getOffset(UDate...) overload, which returns both the raw and the DST offset for a given time. This method is retained only for backward compatibility.

Parameters:

  | era | The reference date's era
  | year | The reference date's year
  | month | The reference date's month (0-based; 0 is January)
  | day | The reference date's day-in-month (1-based)
  | dayOfWeek | The reference date's day-of-week (1-based; 1 is Sunday)
  | millis | The reference date's milliseconds in day, local standard time
  | status | Output param to filled in with a success or an error.

Returns:
  The offset in milliseconds to add to GMT to get local time.

Stable:
  ICU 2.0

Implemented in RuleBasedTimeZone, SimpleTimeZone, and VTimeZone.

Referenced by SimpleTimeZone::getOffset().

virtual int32_t TimeZone::getOffset | ( | uint8_t | era,
|  | int32_t | year,
|  | int32_t | month,
|  | int32_t | day,
|  | uint8_t | dayOfWeek,
|  | int32_t | milliseconds,
|  | int32_t | monthLength,
|  | UErrorCode & | status |
| ) |  |  | const`[pure virtual]`

Gets the time zone offset, for current date, modified in case of daylight savings.

This is the offset to add *to* UTC to get local time.

Note: Don't call this method. Instead, call the getOffset(UDate...) overload, which returns both the raw and the DST offset for a given time. This method is retained only for backward compatibility.

Parameters:

  | era | the era of the given date.
  | year | the year in the given date.
  | month | the month in the given date. Month is 0-based. e.g., 0 for January.
  | day | the day-in-month of the given date.
  | dayOfWeek | the day-of-week of the given date.
  | milliseconds | the millis in day in standard local time.
  | monthLength | the length of the given month in days.
  | status | Output param to filled in with a success or an error.

Returns:
  the offset to add *to* GMT to get local time.

Stable:
  ICU 2.0

Implemented in RuleBasedTimeZone, SimpleTimeZone, and VTimeZone.

virtual void TimeZone::getOffset | ( | UDate | date,
|  | UBool | local,
|  | int32_t & | rawOffset,
|  | int32_t & | dstOffset,
|  | UErrorCode & | ec |
| ) |  |  | const`[virtual]`

Returns the time zone raw and GMT offset for the given moment in time.

Upon return, local-millis = GMT-millis + rawOffset + dstOffset. All computations are performed in the proleptic Gregorian calendar. The default implementation in the TimeZone class delegates to the 8-argument getOffset().

Parameters:

  | date | moment in time for which to return offsets, in units of milliseconds from January 1, 1970 0:00 GMT, either GMT time or local wall time, depending on `local'.
  | local | if true, `date' is local wall time; otherwise it is in GMT time.
  | rawOffset | output parameter to receive the raw offset, that is, the offset not including DST adjustments
  | dstOffset | output parameter to receive the DST offset, that is, the offset to be added to `rawOffset' to obtain the total offset between local and GMT time. If DST is not in effect, this value is zero; otherwise it is a positive value, typically one hour.
  | ec | input-output error code

Stable:
  ICU 2.8

Reimplemented in RuleBasedTimeZone, SimpleTimeZone, and VTimeZone.

virtual void TimeZone::setRawOffset | ( | int32_t | offsetMillis | ) | `[pure virtual]`

Sets the TimeZone's raw GMT offset (i.e., the number of milliseconds to add to GMT to get local time, before taking daylight savings time into account).

Parameters:

  | offsetMillis | The new raw GMT offset for this time zone.

Stable:
  ICU 2.0

Implemented in RuleBasedTimeZone, SimpleTimeZone, and VTimeZone.

virtual int32_t TimeZone::getRawOffset | ( | void |  | ) | const`[pure virtual]`

Returns the TimeZone's raw GMT offset (i.e., the number of milliseconds to add to GMT to get local time, before taking daylight savings time into account).

Returns:
  The TimeZone's raw GMT offset.

Stable:
  ICU 2.0

Implemented in RuleBasedTimeZone, SimpleTimeZone, and VTimeZone.

UnicodeString & TimeZone::getID | ( | UnicodeString & | ID | ) | const`[inline]`

Fills in "ID" with the TimeZone's ID.

Parameters:

  | ID | Receives this TimeZone's ID.

Returns:
  A reference to 'ID'

Stable:
  ICU 2.0

Definition at line 699 of file timezone.h.

void TimeZone::setID | ( | const UnicodeString & | ID | ) | `[inline]`

Sets the TimeZone's ID to the specified value.

This doesn't affect any other fields (for example, if you say< blockquote>

     .     TimeZone* foo = TimeZone::createTimeZone("America/New_York");
     .     foo.setID("America/Los_Angeles");

the time zone's GMT offset and daylight-savings rules don't change to those for Los Angeles. They're still those for New York. Only the ID has changed.)

Parameters:

  | ID | The new timezone ID.

Stable:
  ICU 2.0

Definition at line 708 of file timezone.h.

UnicodeString& TimeZone::getDisplayName | ( | UnicodeString & | result | ) | const

Returns a name of this time zone suitable for presentation to the user in the default locale.

This method returns the long name, not including daylight savings. If the display name is not available for the locale, then this method returns a string in the format `GMT[+-]hh:mm`.

Parameters:

  | result | the human-readable name of this time zone in the default locale.

Returns:
  A reference to 'result'.

Stable:
  ICU 2.0

UnicodeString& TimeZone::getDisplayName | ( | const Locale & | locale,
|  | UnicodeString & | result |
| ) |  |  | const

Returns a name of this time zone suitable for presentation to the user in the specified locale.

This method returns the long name, not including daylight savings. If the display name is not available for the locale, then this method returns a string in the format `GMT[+-]hh:mm`.

Parameters:

  | locale | the locale in which to supply the display name.
  | result | the human-readable name of this time zone in the given locale or in the default locale if the given locale is not recognized.

Returns:
  A reference to 'result'.

Stable:
  ICU 2.0

UnicodeString& TimeZone::getDisplayName | ( | UBool | daylight,
|  | EDisplayType | style,
|  | UnicodeString & | result |
| ) |  |  | const

Returns a name of this time zone suitable for presentation to the user in the default locale.

If the display name is not available for the locale, then this method returns a string in the format `GMT[+-]hh:mm`.

Parameters:

  | daylight | if true, return the daylight savings name.
  | style | either `LONG` or `SHORT`
  | result | the human-readable name of this time zone in the default locale.

Returns:
  A reference to 'result'.

Stable:
  ICU 2.0

UnicodeString& TimeZone::getDisplayName | ( | UBool | daylight,
|  | EDisplayType | style,
|  | const Locale & | locale,
|  | UnicodeString & | result |
| ) |  |  | const

Returns a name of this time zone suitable for presentation to the user in the specified locale.

If the display name is not available for the locale, then this method returns a string in the format `GMT[+-]hh:mm`.

Parameters:

  | daylight | if true, return the daylight savings name.
  | style | either `LONG` or `SHORT`
  | locale | the locale in which to supply the display name.
  | result | the human-readable name of this time zone in the given locale or in the default locale if the given locale is not recognized.

Returns:
  A refence to 'result'.

Stable:
  ICU 2.0

virtual UBool TimeZone::useDaylightTime | ( | void |  | ) | const`[pure virtual]`

Queries if this time zone uses daylight savings time.

Returns:
  true if this time zone uses daylight savings time, false, otherwise.

Stable:
  ICU 2.0

Implemented in RuleBasedTimeZone, SimpleTimeZone, and VTimeZone.

virtual UBool TimeZone::inDaylightTime | ( | UDate | date,
|  | UErrorCode & | status |
| ) |  |  | const`[pure virtual]`

Queries if the given date is in daylight savings time in this time zone.

This method is wasteful since it creates a new GregorianCalendar and deletes it each time it is called. This is a deprecated method and provided only for Java compatibility.

Parameters:

  | date | the given UDate.
  | status | Output param filled in with success/error code.

Returns:
  true if the given date is in daylight savings time, false, otherwise.

Deprecated:
  ICU 2.4. Use Calendar::inDaylightTime() instead.

Implemented in RuleBasedTimeZone, SimpleTimeZone, and VTimeZone.

virtual UBool TimeZone::hasSameRules | ( | const TimeZone & | other | ) | const`[virtual]`

Returns true if this zone has the same rule and offset as another zone.

That is, if this zone differs only in ID, if at all.

Parameters:

  | other | the `TimeZone` object to be compared with

Returns:
  true if the given zone is the same as this one, with the possible exception of the ID

Stable:
  ICU 2.0

Reimplemented in RuleBasedTimeZone, SimpleTimeZone, and VTimeZone.

virtual TimeZone* TimeZone::clone | ( | void |  | ) | const`[pure virtual]`

Clones TimeZone objects polymorphically.

Clients are responsible for deleting the TimeZone object cloned.

Returns:
  A new copy of this TimeZone object.

Stable:
  ICU 2.0

Implemented in RuleBasedTimeZone, SimpleTimeZone, and VTimeZone.

static UClassID TimeZone::getStaticClassID | ( | void |  | ) | `[static]`

Return the class ID for this class.

This is useful only for comparing to a return value from getDynamicClassID().

Returns:
  The class ID for all objects of this class.

Stable:
  ICU 2.0

Reimplemented in RuleBasedTimeZone, SimpleTimeZone, and VTimeZone.

virtual UClassID TimeZone::getDynamicClassID | ( | void |  | ) | const`[pure virtual]`

Returns a unique class ID POLYMORPHICALLY.

This method is to implement a simple version of RTTI, since not all C++ compilers support genuine RTTI. Polymorphic operator==() and clone() methods call this method.

Concrete subclasses of TimeZone must use the UOBJECT_DEFINE_RTTI_IMPLEMENTATION macro from uobject.h in their implementation to provide correct RTTI information.

Returns:
  The class ID for this object. All objects of a given class have the same class ID. Objects of other classes have different class IDs.

Stable:
  ICU 2.0

Implements UObject.

Implemented in RuleBasedTimeZone, SimpleTimeZone, and VTimeZone.

virtual int32_t TimeZone::getDSTSavings | ( |  | ) | const`[virtual]`

Returns the amount of time to be added to local standard time to get local wall clock time.

The default implementation always returns 3600000 milliseconds (i.e., one hour) if this time zone observes Daylight Saving Time. Otherwise, 0 (zero) is returned.

If an underlying TimeZone implementation subclass supports historical Daylight Saving Time changes, this method returns the known latest daylight saving value.

Returns:
  the amount of saving time in milliseconds

Stable:
  ICU 3.6

Reimplemented in SimpleTimeZone.

TimeZone& TimeZone::operator= | ( | const TimeZone & | right | ) | `[protected]`

Default assignment operator.

Parameters:

  | right | the object to be copied.

Stable:
  ICU 2.0

static UResourceBundle* TimeZone::loadRule | ( | const UResourceBundle * | top,
|  | const UnicodeString & | ruleid,
|  | UResourceBundle * | oldbundle,
|  | UErrorCode & | status |
| ) |  |  | `[static, protected]`

Utility function.

For internally loading rule data.

Parameters:

  | top | Top resource bundle for tz data
  | ruleid | ID of rule to load
  | oldbundle | Old bundle to reuse or NULL
  | status | Status parameter

Returns:
  either a new bundle or *oldbundle

Internal:
  Do not use. This API is for interal use only.

The documentation for this class was generated from the following file:

- timezone.h